﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com


namespace PowerClient
{
	public class Operation : INotifyPropertyChanged
	{
		#region INotifyPropertyChanged Members
		public event PropertyChangedEventHandler PropertyChanged;
		protected virtual void OnPropertyChanged(string PropertyName)
		{
			if(PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
		}
		#endregion

		private Operator _Operator;
		public Operator Operator
		{
			get { return _Operator; }
			set { _Operator = value; OnPropertyChanged("Operator"); }
		}

		private double _Operand1;
		public double Operand1
		{
			get { return _Operand1; }
			set { _Operand1 = value; OnPropertyChanged("Operand1"); }
		}

		private double _Operand2;
		public double Operand2
		{
			get { return _Operand2; }
			set { _Operand2 = value; OnPropertyChanged("Operand2"); }
		}

		private bool _IsValid;
		public bool IsValid
		{
			get { return _IsValid; }
			set { _IsValid = value; OnPropertyChanged("IsValid"); }
		}

		private double _Result;
		public double Result
		{
			get { return _Result; }
			set
			{
				_Result = value;
				IsValid = true;
				OnPropertyChanged("Result");
			}
		}
	}

	public enum Operator
	{
		Sum,
		Sub,
		Mul,
		Div,
	}
}
