﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace Service
{
	[ServiceContract(Namespace = "http://schemas.iamraf.net/Calculator")]
	public interface ICalculator
	{
		[OperationContract]
		double Sum(double x, double y);

		[OperationContract]
		double Mul(double x, double y);

		[OperationContract]
		double Sub(double x, double y);

		[OperationContract]
		double Div(double x, double y);
	}


	public class CalculatorV1 : ICalculator
	{
		public double Sum(double x, double y)
		{
			Console.WriteLine("Calculator1.Sum");
			return x + y;
		}

		public double Mul(double x, double y)
		{
			Console.WriteLine("Calculator1.Mul");
			return x * y;
		}

		public double Sub(double x, double y)
		{
			Console.WriteLine("Calculator1.Sub");
			return x - y;
		}

		public double Div(double x, double y)
		{
			Console.WriteLine("Calculator1.Div");
			return x / y;
		}
	}

}
