﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.ServiceModel;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com


namespace Service
{
	public static class ConsoleCloseHelper
	{
		static ServiceHost _host;
		static HandlerRoutine _consoleHandler;

		public static void SetHost(ServiceHost host)
		{
			_host = host;
			_consoleHandler = new HandlerRoutine(ConsoleCtrlCheck);
			SetConsoleCtrlHandler(_consoleHandler, true);
		}

		private static bool ConsoleCtrlCheck(CtrlTypes ctrlType)
		{
			_host.Close();
			return true;
		}

		[DllImport("Kernel32")]
		public static extern bool SetConsoleCtrlHandler(HandlerRoutine Handler, bool Add);

		public delegate bool HandlerRoutine(CtrlTypes CtrlType);
		public enum CtrlTypes
		{
			CTRL_C_EVENT = 0,
			CTRL_BREAK_EVENT,
			CTRL_CLOSE_EVENT,
			CTRL_LOGOFF_EVENT = 5,
			CTRL_SHUTDOWN_EVENT
		}
	}
}
